-- Copyright (C) 2018  Intel Corporation. All rights reserved.
-- Your use of Intel Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Intel Program License 
-- Subscription Agreement, the Intel Quartus Prime License Agreement,
-- the Intel FPGA IP License Agreement, or other applicable license
-- agreement, including, without limitation, that your use is for
-- the sole purpose of programming logic devices manufactured by
-- Intel and sold by Intel or its authorized distributors.  Please
-- refer to the applicable agreement for further details.

-- PROGRAM		"Quartus Prime"
-- VERSION		"Version 18.0.0 Build 614 04/24/2018 SJ Standard Edition"
-- CREATED		"Thu Nov 15 21:41:20 2018"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY projectB IS 
	PORT
	(
		CLK :  IN  STD_LOGIC;
		reset :  IN  STD_LOGIC;
		imemData :  IN  STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END projectB;

ARCHITECTURE bdf_type OF projectB IS 

COMPONENT alu
	PORT(ALU_OP : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		 i_A : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 i_B : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 shamt : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 zero : OUT STD_LOGIC;
		 ALU_out : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT branch_comparator
	PORT(i_rs_data : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 i_rt_data : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 o_equal : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT adder_32
	PORT(i_A : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 i_B : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 o_F : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT shiftby2
	PORT(i_to_add : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		 i_to_shift : IN STD_LOGIC_VECTOR(25 DOWNTO 0);
		 o_combined : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT main_control
	PORT(i_instruction : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 o_reg_dest : OUT STD_LOGIC;
		 o_jump : OUT STD_LOGIC;
		 o_branch : OUT STD_LOGIC;
		 o_mem_to_reg : OUT STD_LOGIC;
		 o_mem_write : OUT STD_LOGIC;
		 o_ALU_src : OUT STD_LOGIC;
		 o_reg_write : OUT STD_LOGIC;
		 o_ALU_op : OUT STD_LOGIC_VECTOR(3 DOWNTO 0)
	);
END COMPONENT;

COMPONENT multiplexer
	PORT(s : IN STD_LOGIC;
		 a : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 b : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 o : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT register_file
	PORT(CLK : IN STD_LOGIC;
		 w_en : IN STD_LOGIC;
		 reset : IN STD_LOGIC;
		 rs_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 rt_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 w_data : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 w_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 rs_data : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 rt_data : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT and_2
	PORT(i_A : IN STD_LOGIC;
		 i_B : IN STD_LOGIC;
		 o_F : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT sll_2
	PORT(i_to_shift : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 o_shifted : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT if_id
	PORT(CLK : IN STD_LOGIC;
		 id_flush : IN STD_LOGIC;
		 id_stall : IN STD_LOGIC;
		 ifid_reset : IN STD_LOGIC;
		 if_instruction : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 if_pc_plus_4 : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 id_instruction : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 id_pc_plus_4 : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT id_ex
	PORT(CLK : IN STD_LOGIC;
		 ex_flush : IN STD_LOGIC;
		 ex_stall : IN STD_LOGIC;
		 idex_reset : IN STD_LOGIC;
		 id_reg_dest : IN STD_LOGIC;
		 id_branch : IN STD_LOGIC;
		 id_mem_to_reg : IN STD_LOGIC;
		 id_mem_write : IN STD_LOGIC;
		 id_ALU_src : IN STD_LOGIC;
		 id_reg_write : IN STD_LOGIC;
		 id_ALU_op : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		 id_extended_immediate : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 id_instruction : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 id_pc_plus_4 : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 id_rd_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 id_rs_data : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 id_rs_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 id_rt_data : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 id_rt_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 ex_reg_dest : OUT STD_LOGIC;
		 ex_branch : OUT STD_LOGIC;
		 ex_mem_to_reg : OUT STD_LOGIC;
		 ex_mem_write : OUT STD_LOGIC;
		 ex_ALU_src : OUT STD_LOGIC;
		 ex_reg_write : OUT STD_LOGIC;
		 ex_ALU_op : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
		 ex_extended_immediate : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 ex_instruction : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 ex_pc_plus_4 : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 ex_rd_sel : OUT STD_LOGIC_VECTOR(4 DOWNTO 0);
		 ex_rs_data : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 ex_rs_sel : OUT STD_LOGIC_VECTOR(4 DOWNTO 0);
		 ex_rt_data : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 ex_rt_sel : OUT STD_LOGIC_VECTOR(4 DOWNTO 0)
	);
END COMPONENT;

COMPONENT ex_mem
	PORT(CLK : IN STD_LOGIC;
		 mem_flush : IN STD_LOGIC;
		 mem_stall : IN STD_LOGIC;
		 exmem_reset : IN STD_LOGIC;
		 ex_reg_dest : IN STD_LOGIC;
		 ex_mem_to_reg : IN STD_LOGIC;
		 ex_mem_write : IN STD_LOGIC;
		 ex_reg_write : IN STD_LOGIC;
		 ex_ALU_out : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 ex_instruction : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 ex_pc_plus_4 : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 ex_rt_data : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 ex_write_reg_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 mem_reg_dest : OUT STD_LOGIC;
		 mem_mem_to_reg : OUT STD_LOGIC;
		 mem_mem_write : OUT STD_LOGIC;
		 mem_reg_write : OUT STD_LOGIC;
		 mem_ALU_out : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 mem_instruction : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 mem_pc_plus_4 : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 mem_rt_data : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 mem_write_reg_sel : OUT STD_LOGIC_VECTOR(4 DOWNTO 0)
	);
END COMPONENT;

COMPONENT mem_wb
	PORT(CLK : IN STD_LOGIC;
		 wb_flush : IN STD_LOGIC;
		 wb_stall : IN STD_LOGIC;
		 memwb_reset : IN STD_LOGIC;
		 mem_reg_dest : IN STD_LOGIC;
		 mem_mem_to_reg : IN STD_LOGIC;
		 mem_reg_write : IN STD_LOGIC;
		 mem_ALU_out : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 mem_dmem_out : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 mem_instruction : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 mem_pc_plus_4 : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 mem_write_reg_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 wb_reg_dest : OUT STD_LOGIC;
		 wb_mem_to_reg : OUT STD_LOGIC;
		 wb_reg_write : OUT STD_LOGIC;
		 wb_ALU_out : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 wb_dmem_out : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 wb_instruction : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 wb_pc_plus_4 : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		 wb_write_reg_sel : OUT STD_LOGIC_VECTOR(4 DOWNTO 0)
	);
END COMPONENT;

COMPONENT dmem
GENERIC (depth_exp_of_2 : INTEGER;
			mif_filename : STRING
			);
	PORT(clock : IN STD_LOGIC;
		 wren : IN STD_LOGIC;
		 address : IN STD_LOGIC_VECTOR(9 DOWNTO 0);
		 byteena : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		 data : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 q : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT hazard_detection
	PORT(CLK : IN STD_LOGIC;
		 ex_mem_to_reg : IN STD_LOGIC;
		 o_jump : IN STD_LOGIC;
		 o_branch : IN STD_LOGIC;
		 o_equal : IN STD_LOGIC;
		 ex_rt_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 ex_wb : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 id_rs_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 id_rt_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 id_flush : OUT STD_LOGIC;
		 ex_flush : OUT STD_LOGIC;
		 o_stall : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT pc_reg
	PORT(CLK : IN STD_LOGIC;
		 reset : IN STD_LOGIC;
		 stall : IN STD_LOGIC;
		 i_next_PC : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 o_PC : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT forwarding
	PORT(mem_reg_write : IN STD_LOGIC;
		 wb_reg_write : IN STD_LOGIC;
		 ex_instruction : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 ex_rs_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 ex_rt_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 id_instruction : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 id_rs_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 id_rt_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 mem_write_reg_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 wb_instruction : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 wb_write_reg_sel : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 rs_comp_mux_sel : OUT STD_LOGIC;
		 rt_comp_mux_sel : OUT STD_LOGIC;
		 sw_select : OUT STD_LOGIC;
		 rs_mux_sel : OUT STD_LOGIC_VECTOR(1 DOWNTO 0);
		 rt_mux_sel : OUT STD_LOGIC_VECTOR(1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT multiplexerfourtoone
	PORT(a : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 b : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 c : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 d : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 s : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 o : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT imem
GENERIC (depth_exp_of_2 : INTEGER;
			mif_filename : STRING
			);
	PORT(clock : IN STD_LOGIC;
		 wren : IN STD_LOGIC;
		 address : IN STD_LOGIC_VECTOR(9 DOWNTO 0);
		 byteena : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		 data : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 q : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

COMPONENT mux21_5bit
	PORT(i_sel : IN STD_LOGIC;
		 i_0 : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 i_1 : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 o_mux : OUT STD_LOGIC_VECTOR(4 DOWNTO 0)
	);
END COMPONENT;

COMPONENT sign_extender_16_32
	PORT(i_to_extend : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 o_extended : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	byteena0 :  STD_LOGIC;
SIGNAL	byteena1 :  STD_LOGIC;
SIGNAL	byteena2 :  STD_LOGIC;
SIGNAL	byteena20 :  STD_LOGIC;
SIGNAL	byteena21 :  STD_LOGIC;
SIGNAL	byteena22 :  STD_LOGIC;
SIGNAL	byteena23 :  STD_LOGIC;
SIGNAL	byteena3 :  STD_LOGIC;
SIGNAL	i_A :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	id_instruction :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	id_pc_plus_4 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	mem_ALU_out :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	o_F :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	o_PC :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_0 :  STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_1 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_2 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_3 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_4 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_94 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_6 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_7 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_8 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_9 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_95 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_11 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_96 :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_97 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_98 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_15 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_99 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_17 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_100 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_19 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_101 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_21 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_22 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_23 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_24 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_26 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_27 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_28 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_29 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_30 :  STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_102 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_103 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_104 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_105 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_38 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_39 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_40 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_106 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_42 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_43 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_107 :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_108 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_47 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_48 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_109 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_50 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_51 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_52 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_110 :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_54 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_55 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_111 :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_62 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_65 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_69 :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_72 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_74 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_112 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_113 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_77 :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_78 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_81 :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_82 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_114 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_84 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_86 :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_87 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_90 :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_91 :  STD_LOGIC;

SIGNAL	GDFX_TEMP_SIGNAL_0 :  STD_LOGIC_VECTOR(0 TO 3);
SIGNAL	GDFX_TEMP_SIGNAL_3 :  STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL	GDFX_TEMP_SIGNAL_1 :  STD_LOGIC_VECTOR(0 TO 3);
SIGNAL	GDFX_TEMP_SIGNAL_2 :  STD_LOGIC_VECTOR(3 DOWNTO 0);

BEGIN 
SYNTHESIZED_WIRE_23 <= '0';
SYNTHESIZED_WIRE_103 <= '0';
SYNTHESIZED_WIRE_108 <= '0';
SYNTHESIZED_WIRE_87 <= '0';

byteena3 <= GDFX_TEMP_SIGNAL_0(0);
byteena2 <= GDFX_TEMP_SIGNAL_0(1);
byteena1 <= GDFX_TEMP_SIGNAL_0(2);
byteena0 <= GDFX_TEMP_SIGNAL_0(3);

GDFX_TEMP_SIGNAL_3 <= (byteena3 & byteena2 & byteena1 & byteena0);
byteena23 <= GDFX_TEMP_SIGNAL_1(0);
byteena22 <= GDFX_TEMP_SIGNAL_1(1);
byteena21 <= GDFX_TEMP_SIGNAL_1(2);
byteena20 <= GDFX_TEMP_SIGNAL_1(3);

GDFX_TEMP_SIGNAL_2 <= (byteena23 & byteena22 & byteena21 & byteena20);


b2v_inst : alu
PORT MAP(ALU_OP => SYNTHESIZED_WIRE_0,
		 i_A => SYNTHESIZED_WIRE_1,
		 i_B => SYNTHESIZED_WIRE_2,
		 shamt => id_instruction(4 DOWNTO 0),
		 ALU_out => SYNTHESIZED_WIRE_40);


b2v_inst1 : branch_comparator
PORT MAP(i_rs_data => SYNTHESIZED_WIRE_3,
		 i_rt_data => SYNTHESIZED_WIRE_4,
		 o_equal => SYNTHESIZED_WIRE_98);


b2v_inst10 : adder_32
PORT MAP(i_A => i_A,
		 i_B => o_PC,
		 o_F => o_F);


b2v_inst11 : shiftby2
PORT MAP(i_to_add => id_pc_plus_4(31 DOWNTO 28),
		 i_to_shift => id_instruction(25 DOWNTO 0),
		 o_combined => SYNTHESIZED_WIRE_7);



b2v_inst14 : main_control
PORT MAP(i_instruction => id_instruction,
		 o_reg_dest => SYNTHESIZED_WIRE_24,
		 o_jump => SYNTHESIZED_WIRE_94,
		 o_branch => SYNTHESIZED_WIRE_97,
		 o_mem_to_reg => SYNTHESIZED_WIRE_26,
		 o_mem_write => SYNTHESIZED_WIRE_27,
		 o_ALU_src => SYNTHESIZED_WIRE_28,
		 o_reg_write => SYNTHESIZED_WIRE_29,
		 o_ALU_op => SYNTHESIZED_WIRE_30);





b2v_inst18 : multiplexer
PORT MAP(s => SYNTHESIZED_WIRE_94,
		 a => SYNTHESIZED_WIRE_6,
		 b => SYNTHESIZED_WIRE_7,
		 o => SYNTHESIZED_WIRE_65);


b2v_inst19 : multiplexer
PORT MAP(s => SYNTHESIZED_WIRE_8,
		 a => o_F,
		 b => SYNTHESIZED_WIRE_9,
		 o => SYNTHESIZED_WIRE_6);


b2v_inst2 : register_file
PORT MAP(CLK => CLK,
		 w_en => SYNTHESIZED_WIRE_95,
		 reset => reset,
		 rs_sel => id_instruction(25 DOWNTO 21),
		 rt_sel => id_instruction(20 DOWNTO 16),
		 w_data => SYNTHESIZED_WIRE_11,
		 w_sel => SYNTHESIZED_WIRE_96,
		 rs_data => SYNTHESIZED_WIRE_102,
		 rt_data => SYNTHESIZED_WIRE_99);


b2v_inst20 : and_2
PORT MAP(i_A => SYNTHESIZED_WIRE_97,
		 i_B => SYNTHESIZED_WIRE_98,
		 o_F => SYNTHESIZED_WIRE_8);


b2v_inst21 : multiplexer
PORT MAP(s => SYNTHESIZED_WIRE_15,
		 a => SYNTHESIZED_WIRE_99,
		 b => mem_ALU_out,
		 o => SYNTHESIZED_WIRE_4);


b2v_inst22 : adder_32
PORT MAP(i_A => id_pc_plus_4,
		 i_B => SYNTHESIZED_WIRE_17,
		 o_F => SYNTHESIZED_WIRE_9);


b2v_inst23 : sll_2
PORT MAP(i_to_shift => SYNTHESIZED_WIRE_100,
		 o_shifted => SYNTHESIZED_WIRE_17);


b2v_inst24 : if_id
PORT MAP(CLK => CLK,
		 id_flush => SYNTHESIZED_WIRE_19,
		 id_stall => SYNTHESIZED_WIRE_101,
		 ifid_reset => reset,
		 if_instruction => SYNTHESIZED_WIRE_21,
		 if_pc_plus_4 => o_F,
		 id_instruction => id_instruction,
		 id_pc_plus_4 => id_pc_plus_4);




b2v_inst27 : id_ex
PORT MAP(CLK => CLK,
		 ex_flush => SYNTHESIZED_WIRE_22,
		 ex_stall => SYNTHESIZED_WIRE_23,
		 idex_reset => reset,
		 id_reg_dest => SYNTHESIZED_WIRE_24,
		 id_branch => SYNTHESIZED_WIRE_97,
		 id_mem_to_reg => SYNTHESIZED_WIRE_26,
		 id_mem_write => SYNTHESIZED_WIRE_27,
		 id_ALU_src => SYNTHESIZED_WIRE_28,
		 id_reg_write => SYNTHESIZED_WIRE_29,
		 id_ALU_op => SYNTHESIZED_WIRE_30,
		 id_extended_immediate => SYNTHESIZED_WIRE_100,
		 id_instruction => id_instruction,
		 id_pc_plus_4 => id_pc_plus_4,
		 id_rd_sel => id_instruction(15 DOWNTO 11),
		 id_rs_data => SYNTHESIZED_WIRE_102,
		 id_rs_sel => id_instruction(25 DOWNTO 21),
		 id_rt_data => SYNTHESIZED_WIRE_99,
		 id_rt_sel => id_instruction(20 DOWNTO 16),
		 ex_reg_dest => SYNTHESIZED_WIRE_104,
		 ex_mem_to_reg => SYNTHESIZED_WIRE_105,
		 ex_mem_write => SYNTHESIZED_WIRE_38,
		 ex_ALU_src => SYNTHESIZED_WIRE_84,
		 ex_reg_write => SYNTHESIZED_WIRE_39,
		 ex_ALU_op => SYNTHESIZED_WIRE_0,
		 ex_extended_immediate => SYNTHESIZED_WIRE_86,
		 ex_instruction => SYNTHESIZED_WIRE_106,
		 ex_pc_plus_4 => SYNTHESIZED_WIRE_42,
		 ex_rd_sel => SYNTHESIZED_WIRE_90,
		 ex_rs_data => SYNTHESIZED_WIRE_78,
		 ex_rs_sel => SYNTHESIZED_WIRE_69,
		 ex_rt_data => SYNTHESIZED_WIRE_114,
		 ex_rt_sel => SYNTHESIZED_WIRE_111);


b2v_inst28 : ex_mem
PORT MAP(CLK => CLK,
		 mem_flush => SYNTHESIZED_WIRE_103,
		 mem_stall => SYNTHESIZED_WIRE_103,
		 exmem_reset => reset,
		 ex_reg_dest => SYNTHESIZED_WIRE_104,
		 ex_mem_to_reg => SYNTHESIZED_WIRE_105,
		 ex_mem_write => SYNTHESIZED_WIRE_38,
		 ex_reg_write => SYNTHESIZED_WIRE_39,
		 ex_ALU_out => SYNTHESIZED_WIRE_40,
		 ex_instruction => SYNTHESIZED_WIRE_106,
		 ex_pc_plus_4 => SYNTHESIZED_WIRE_42,
		 ex_rt_data => SYNTHESIZED_WIRE_43,
		 ex_write_reg_sel => SYNTHESIZED_WIRE_107,
		 mem_reg_dest => SYNTHESIZED_WIRE_47,
		 mem_mem_to_reg => SYNTHESIZED_WIRE_48,
		 mem_mem_write => SYNTHESIZED_WIRE_54,
		 mem_reg_write => SYNTHESIZED_WIRE_109,
		 mem_ALU_out => mem_ALU_out,
		 mem_instruction => SYNTHESIZED_WIRE_51,
		 mem_pc_plus_4 => SYNTHESIZED_WIRE_52,
		 mem_rt_data => SYNTHESIZED_WIRE_55,
		 mem_write_reg_sel => SYNTHESIZED_WIRE_110);


b2v_inst29 : mem_wb
PORT MAP(CLK => CLK,
		 wb_flush => SYNTHESIZED_WIRE_108,
		 wb_stall => SYNTHESIZED_WIRE_108,
		 memwb_reset => reset,
		 mem_reg_dest => SYNTHESIZED_WIRE_47,
		 mem_mem_to_reg => SYNTHESIZED_WIRE_48,
		 mem_reg_write => SYNTHESIZED_WIRE_109,
		 mem_ALU_out => mem_ALU_out,
		 mem_dmem_out => SYNTHESIZED_WIRE_50,
		 mem_instruction => SYNTHESIZED_WIRE_51,
		 mem_pc_plus_4 => SYNTHESIZED_WIRE_52,
		 mem_write_reg_sel => SYNTHESIZED_WIRE_110,
		 wb_mem_to_reg => SYNTHESIZED_WIRE_91,
		 wb_reg_write => SYNTHESIZED_WIRE_95,
		 wb_ALU_out => SYNTHESIZED_WIRE_112,
		 wb_dmem_out => SYNTHESIZED_WIRE_113,
		 wb_instruction => SYNTHESIZED_WIRE_72,
		 wb_write_reg_sel => SYNTHESIZED_WIRE_96);


b2v_inst3 : dmem
GENERIC MAP(depth_exp_of_2 => 10,
			mif_filename => "dmem.mif"
			)
PORT MAP(clock => CLK,
		 wren => SYNTHESIZED_WIRE_54,
		 address => mem_ALU_out(11 DOWNTO 2),
		 byteena => GDFX_TEMP_SIGNAL_2,
		 data => SYNTHESIZED_WIRE_55,
		 q => SYNTHESIZED_WIRE_50);


b2v_inst30 : hazard_detection
PORT MAP(CLK => CLK,
		 ex_mem_to_reg => SYNTHESIZED_WIRE_105,
		 o_jump => SYNTHESIZED_WIRE_94,
		 o_branch => SYNTHESIZED_WIRE_97,
		 o_equal => SYNTHESIZED_WIRE_98,
		 ex_rt_sel => SYNTHESIZED_WIRE_111,
		 ex_wb => SYNTHESIZED_WIRE_107,
		 id_rs_sel => id_instruction(25 DOWNTO 21),
		 id_rt_sel => id_instruction(20 DOWNTO 16),
		 id_flush => SYNTHESIZED_WIRE_19,
		 ex_flush => SYNTHESIZED_WIRE_22,
		 o_stall => SYNTHESIZED_WIRE_101);




b2v_inst34 : multiplexer
PORT MAP(s => SYNTHESIZED_WIRE_62,
		 a => SYNTHESIZED_WIRE_102,
		 b => mem_ALU_out,
		 o => SYNTHESIZED_WIRE_3);


b2v_inst35 : pc_reg
PORT MAP(CLK => CLK,
		 reset => reset,
		 stall => SYNTHESIZED_WIRE_101,
		 i_next_PC => SYNTHESIZED_WIRE_65,
		 o_PC => o_PC);


b2v_inst36 : forwarding
PORT MAP(mem_reg_write => SYNTHESIZED_WIRE_109,
		 wb_reg_write => SYNTHESIZED_WIRE_95,
		 ex_instruction => SYNTHESIZED_WIRE_106,
		 ex_rs_sel => SYNTHESIZED_WIRE_69,
		 ex_rt_sel => SYNTHESIZED_WIRE_111,
		 id_instruction => id_instruction,
		 id_rs_sel => id_instruction(25 DOWNTO 21),
		 id_rt_sel => id_instruction(20 DOWNTO 16),
		 mem_write_reg_sel => SYNTHESIZED_WIRE_110,
		 wb_instruction => SYNTHESIZED_WIRE_72,
		 wb_write_reg_sel => SYNTHESIZED_WIRE_96,
		 rs_comp_mux_sel => SYNTHESIZED_WIRE_62,
		 rt_comp_mux_sel => SYNTHESIZED_WIRE_15,
		 sw_select => SYNTHESIZED_WIRE_82,
		 rs_mux_sel => SYNTHESIZED_WIRE_81,
		 rt_mux_sel => SYNTHESIZED_WIRE_77);


b2v_inst37 : multiplexerfourtoone
PORT MAP(a => SYNTHESIZED_WIRE_74,
		 b => mem_ALU_out,
		 c => SYNTHESIZED_WIRE_112,
		 d => SYNTHESIZED_WIRE_113,
		 s => SYNTHESIZED_WIRE_77,
		 o => SYNTHESIZED_WIRE_2);


b2v_inst38 : multiplexerfourtoone
PORT MAP(a => SYNTHESIZED_WIRE_78,
		 b => mem_ALU_out,
		 c => SYNTHESIZED_WIRE_112,
		 d => SYNTHESIZED_WIRE_113,
		 s => SYNTHESIZED_WIRE_81,
		 o => SYNTHESIZED_WIRE_1);


b2v_inst39 : multiplexer
PORT MAP(s => SYNTHESIZED_WIRE_82,
		 a => SYNTHESIZED_WIRE_114,
		 b => mem_ALU_out,
		 o => SYNTHESIZED_WIRE_43);


b2v_inst4 : multiplexer
PORT MAP(s => SYNTHESIZED_WIRE_84,
		 a => SYNTHESIZED_WIRE_114,
		 b => SYNTHESIZED_WIRE_86,
		 o => SYNTHESIZED_WIRE_74);



b2v_inst6 : imem
GENERIC MAP(depth_exp_of_2 => 10,
			mif_filename => "imem.mif"
			)
PORT MAP(clock => CLK,
		 wren => SYNTHESIZED_WIRE_87,
		 address => o_PC(11 DOWNTO 2),
		 byteena => GDFX_TEMP_SIGNAL_3,
		 data => imemData,
		 q => SYNTHESIZED_WIRE_21);


b2v_inst7 : mux21_5bit
PORT MAP(i_sel => SYNTHESIZED_WIRE_104,
		 i_0 => SYNTHESIZED_WIRE_111,
		 i_1 => SYNTHESIZED_WIRE_90,
		 o_mux => SYNTHESIZED_WIRE_107);


b2v_inst8 : sign_extender_16_32
PORT MAP(i_to_extend => id_instruction(15 DOWNTO 0),
		 o_extended => SYNTHESIZED_WIRE_100);


b2v_inst9 : multiplexer
PORT MAP(s => SYNTHESIZED_WIRE_91,
		 a => SYNTHESIZED_WIRE_112,
		 b => SYNTHESIZED_WIRE_113,
		 o => SYNTHESIZED_WIRE_11);


byteena0 <= GDFX_TEMP_SIGNAL_0(3);
byteena1 <= GDFX_TEMP_SIGNAL_0(2);
byteena2 <= GDFX_TEMP_SIGNAL_0(1);
byteena20 <= GDFX_TEMP_SIGNAL_1(3);
byteena21 <= GDFX_TEMP_SIGNAL_1(2);
byteena22 <= GDFX_TEMP_SIGNAL_1(1);
byteena23 <= GDFX_TEMP_SIGNAL_1(0);
byteena3 <= GDFX_TEMP_SIGNAL_0(0);
i_A(2) <= '1';
i_A(1 DOWNTO 0) <= "00";
i_A(31 DOWNTO 3) <= "00000000000000000000000000000";
END bdf_type;